
// ************************************************************************
// *                                                                      *
// * IBM LM78 dll                                                         *
// *                                                                      *
// * Portions written by the IBM Director Development Team                *
// * (C) Copyright IBM Corporation, 1998-2003                             *
// *                                                                      *
// *  This software may be used and distributed according to the terms    *
// *  of the Lesser GNU Public License, incorporated herein by reference. *
// *                                                                      *
// ************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <linux/ioctl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

typedef void* PVOID;
#include "ibmlm78-x.h"


#define DEVS 4
#define TRUE 1    
#define FALSE 0
#define ERROR 	 1    
#define NO_ERROR 0
#define BYTE  unsigned char
#define UCHAR unsigned char



int ibmsmb[DEVS]; /* Device file descriptors */
int DevIdx = 0;

//FxFx: Remove these 
int fd=0;
#define ULONG long
//FxFx: Remove these 


//-----------------------------------------------------------------------------------------------
int LM78_Open()
{
   int modes[DEVS] = {  O_RDONLY, O_WRONLY, O_RDWR };
   // char *mode_names[DEVS] = { "r", "w", "rw" };
   char devname[256];

   //printf("SO: LM78_Open called\n");
   
   // Force to a single device for now.
   DevIdx = 0;

   sprintf(devname,"/dev/ibmlm78%d",0);
   ibmsmb[DevIdx] = open(devname,modes[DevIdx%3]);
	
   //FxFx: Remove this 
   fd = ibmsmb[DevIdx];	
      
   if (ibmsmb[DevIdx] > 0) 
   {
      return TRUE;
   }
   else
   {
      return FALSE;
   }
   
}

//-----------------------------------------------------------------------------------------------
int LM78_Close()
{
   DevIdx = 0;
   close(ibmsmb[DevIdx]);
	
   //printf("SO: LM78_Close called\n");
	
   return TRUE;
}



//-----------------------------------------------------------------------------------------------
int LM78_Send(
BYTE write_addr, 
void *value,
long LM78Fnctn,
int param,
int length)
{
   TLM78WriteParams pParams;
// ULONG outBufferLen;        					 // LinPort: outBufferLen Unused Var
   int success = ERROR;
   unsigned int retVal = 0;

   if (fd<0) 
      return (success);

   pParams.addr = write_addr;
   pParams.data = (int *) value;
   pParams.param = param;   
   if ((retVal = ioctl(fd, LM78Fnctn, &pParams))<0)
   {	   
      //printf ("LM78_Send failed with retcode [%d] \n",retVal);
      success = ERROR;
   }	   
   else
      success = NO_ERROR;

   return (success);
}



//-----------------------------------------------------------------------------------------------
int LM78_Receive(
BYTE read_addr, 
UCHAR *retval,
long LM78Fnctn,
int param,
int length)
{
   TLM78ReadParams params;
// UCHAR outBuffer;        					     // LinPort: outBufferLen Unused Var
// ULONG outBufferLen;        					 // LinPort: outBufferLen Unused Var
   int success = ERROR;
   int retVal = 0;

   //printf("LM78_Receive called\n");
 	
   if (fd<0) 
   {
      //printf("LM78_Receive fd < 0\n");
      return (success);
   }
   //printf("LM78_Receive fd >= 0\n");

   params.addr = read_addr;
   params.length = 1;
   params.param = param;   
   if ((retVal=ioctl(fd, LM78Fnctn, &params))<0)
   {	   
      //printf("LM78_Receive ioclt failed with retval [%d] \n",retVal);
      success = ERROR;   
   }	   
   else
   {
      //printf("LM78_Receive ioclt called and returned success with retcode [%d]\n",retVal);
      success = NO_ERROR;
      *retval = params.data;
   }

   return (success);

}


//-----------------------------------------------------------------------------------------------
int LM78_GPSet(
BYTE write_addr, 
void *value,
long LM78Fnctn,
int length)
{

   TSwitchPIIXGPO pParams;
// ULONG outBufferLen;        					     // LinPort: outBufferLen Unused Var
   int success = ERROR;
	unsigned int retVal = 0;

   if (fd<0) 
      return (success);
   
   pParams.addr = write_addr;
	pParams.data = *((UCHAR *)value);
   if ((retVal = ioctl(fd, LM78Fnctn, &pParams))<0)
   {		   
      //printf("LM78_GPSet failed with retcode [%d] \n",retVal);
      success = ERROR;   
   }		   
   else
      success = NO_ERROR;

   return (success);

}



//-----------------------------------------------------------------------------------------------
int LM78_GPIOSet(
BYTE write_addr, 
void *value,
void *mask,
long LM78Fnctn,
int length)
{
   TSwitch307GPIO pParams;
// ULONG outBufferLen;        					     // LinPort: outBufferLen Unused Var
   int success = ERROR;
	unsigned int retVal = 0;
   
   if (fd<0) 
      return (success);

   pParams.addr = write_addr;
   pParams.data = *((UCHAR *)value);
   pParams.mask = *((UCHAR *)mask);
   if ((retVal = ioctl(fd, LM78Fnctn, &pParams))<0)
   {		   
      //printf("LM78_GPIOSet call failed with retval [%d] \n",retVal);
      success = ERROR;   
   }	   
   else
   {
      //printf("LM78_GPIOSet call returned success\n");
      success = NO_ERROR;
   }

   return (success);
}



/*  
//-----------------------------------------------------------------------------------------------
int main(int argc, char * argv[])
{
	int i;
	char buffer[256];

	LM78_Open();

          //  do some testing using "buffer[256]"

	LM78_Close();
}
*/
